/* eval.h */
/* Last modified: June 6, 2007 */


/* passed pawn pair bonus based on rank */
static int pppBonus[] = {0, 32, 64, 125, 250, 500, 750};


/* multiplier, etc */
#define KING_RACE_FACTOR                       2


/* king too advanced penalty */
static int kRankPenalty[] = {0, 16, 48, 64, 128, 128, 128, 128};


/* Initial king safety counter depending on where the king is */
static ui wKsfCounter[] = {2, 0, 0, 0, 0, 0, 0, 2,
		           2, 1, 1, 1, 1, 1, 1, 2,
		           4, 3, 3, 3, 3, 3, 3, 4,
		           4, 4, 4, 4, 4, 4, 4, 4,
		           4, 4, 4, 4, 4, 4, 4, 4,
		           4, 4, 4, 4, 4, 4, 4, 4,
		           4, 4, 4, 4, 4, 4, 4, 4,
		           4, 4, 4, 4, 4, 4, 4, 4};

static ui bKsfCounter[] = {4, 4, 4, 4, 4, 4, 4, 4,
		           4, 4, 4, 4, 4, 4, 4, 4,
		           4, 4, 4, 4, 4, 4, 4, 4,
		           4, 4, 4, 4, 4, 4, 4, 4,
		           4, 4, 4, 4, 4, 4, 4, 4,
		           4, 3, 3, 3, 3, 3, 3, 4,
		           2, 1, 1, 1, 1, 1, 1, 2,
		           2, 0, 0, 0, 0, 0, 0, 2};

/* Additional king safety counter depends on the 
   combination of opponent pieces attacking king */
static ui ksfFlagToCounter[] =
  {/* N are for knight or bishop
      x P N N R R R R Q Q Q Q Q Q Q Q K K K K K K K K K K K K K K K K
      x  x  P x P N N x P N N R R R Rx  P N N R R R R Q Q Q Q Q Q Q Q 
      x  x  x  x  x P x  x  P x P N N x  x  P x P N N x P N N R R R R  
      x  x  x  x  x  x  x  x  x  x  P x  x  x  x  x P x  x  P x P N N
      x  x  x  x  x  x  x  x  x  x  x  x  x  x  x  x  x  x  x  x  x P 
   */
      0,0,0,0,0,0,1,1,0,1,2,2,2,3,3,3,0,0,0,0,1,1,2,2,2,3,3,3,3,3,3,3};

/* Now translate the counter into a real value */
static ui ksfTable[] = {  0,   1,   2,   3,   6,   9,  13,  18,  25,  38,
 		         50,  63,  75,  88, 100, 113, 125, 138, 150, 163,
		        175, 188, 200, 213, 225, 238, 250, 263, 275, 288,
			300, 325, 350, 375, 400, 425, 450, 500, 550, 600,
			600, 600, 600, 600, 600, 600, 600, 600, 600, 600,
		        600, 600, 600, 600, 600, 600, 600, 600, 600, 600};
