/* prototypes.h */
/* Last modified: June 9, 2007 */


#ifdef WINDOWS
#include <time.h>
#else
#include <sys/time.h>
#endif


/* attack.c */
void initRankAttacks(void);
ui isSqAttackedByWP(ui sq, sPos *pos, sOthers *others);
ui isSqAttackedByWN(ui sq, sPos *pos, sOthers *others);
ui isSqAttackedByWK(ui sq, sPos *pos, sOthers *others);
ui isInCheckByW(ui sq, BB *Attackers, sPos *pos, sOthers *others);
ui isSqAttackableByW(ui sq, sPos *pos, sOthers *others);
ui isSqAttackedByBP(ui sq, sPos *pos, sOthers *others);
ui isSqAttackedByBN(ui sq, sPos *pos, sOthers *others);
ui isSqAttackedByBK(ui sq, sPos *pos, sOthers *others);
ui isInCheckByB(ui sq, BB *Attackers, sPos *pos, sOthers *others);
ui isSqAttackableByB(ui sq, sPos *pos, sOthers *others);
ui getWAttacker(ui sq, sPos *pos, sPlyData *thisPlyData, sOthers *others);
ui getBAttacker(ui sq, sPos *pos, sPlyData *thisPlyData, sOthers *others);
ui pinner(ui pinneeColor, ui pinnee, ui pinKing, sPos *pos, 
	  sOthers *others);
BB ambusher(ui sq, int direction, sPos *pos, sOthers *others);
int valueAtSq(ui sq, sPos *pos);
int see(ui wToMove, ui sq, ui t, sPos *pos, sOthers *others);


/* book.c */
void readPGN(char *file, char *player, int numberOfMoves);
void whiteFEN(ui wToMove, sPos *pos, sPlyData *plyData, sHash **hash,
	      sOthers *others);
void blackFEN(ui wToMove, sPos *pos, sPlyData *plyData, sHash **hash,
	      sOthers *others);
void readTextBooks(ui wToMove, sPos *pos, sPlyData *plyData, sHash **hash, 
		   sOthers *others);
void readBinaryBooks(void);
BB openingBook(ui wToMove, char *usedWNo, char *usedBNo,
	       sPlyData *thisPlyData, sPos *pos);


/* command.c */
void *thread_function(void *arg);
#ifdef _REENTRANT
void *getCommand(void *arg);
#else
void getCommand();
#endif
ui processCommand(char *word0, char *word1, char *word2, char *word3,
		  char *word4, char *word5, char *word6, char *word7,
		  char *word8, char *word9, char *word10, char *word11,
		  ui *wToMove, sPos *pos, sPlyData *plyData, sHash **hash, 
		  sOthers *others, ui acceptDraw, FILE *fd);


/* egtbprobe.c */
int EGTBProbe (ui wToMove, int *score, sPos *pos, sPlyData *thisPlyData);


/* eval.c */
int evalMaterial(sPos *thiPos, sOthers *others, int *wPieceScore, 
		 int *bPieceScore, int *doubleBonus);
int wKPenalty(ui ply, sPos *pos, sPlyData *plyData, sOthers *others);
int bKPenalty(ui ply, sPos *pos, sPlyData *plyData, sOthers *others);
int eval(ui wToMove, ui ply, sPos *pos, sPlyData *plyData, sOthers *others, 
	 int lScore, int wPieceScore, int bPieceScore, int alpha, 
	 int doubleBonus);
ui noPotentialPPawn(sPos *pos);
int bonusFor7thRank(ui side, ui rank, ui fyle, sPos *pos);
void revalWOpening(BB move, sPos *pos);
void revalBOpening(BB move, sPos *pos);
void reval(BB move, sPos *pos, sOthers *others);
ui isDrawByRule(ui ply, sPos *pos, sPlyData *thisPlyData);


/* hash.c */
void hashStore(ui wToMove, ui ply, ui depth, int score, ui from, ui to, 
	       ui mateTreat, ui hashFlag, sPlyData *thisPlyData, sHash **hash,
	       sPos *pos);
int hashProbe(ui wToMove, ui ply, ui depth, int *score, ui *from1, 
	      ui *to2, ui *mateThreat, ui *hashFlag, 
	      sPlyData *thisPlyData, sHash **hash, sPos *pos);


/* init.c */
void initBitBoards(sOthers *others);
void init(ui *wToMove, sPos *pos, sPlyData *plyData, sHash **hash, 
	  sOthers *others);
void initKeys(sOthers *others);
void clearHash(sHash **hash, sPos *pos);
void finalizeInit(ui *piece, sPos *pos, sPlyData *thisPlyData,
		  sOthers *others);
void initPosBoard(ui *wToMove, sPos *pos, sPlyData *thisPlyData, 
		  sOthers *others);
BB scanBoard(ui *piece, BB EP, int wCanCastle, int bCanCastle,
	       sPos *pos, sOthers *others);
void readSqvalue(sOthers *others);


/* move.c */
ui testMove(ui wToMove, ui ply, BB move, sPos *pos, sPlyData *plyData, 
	    sOthers *others);
ui qcaptures(ui wToMove, ui ply, BB *moveList, sPos *pos, 
	    sPlyData *plyData, sOthers *others);
ui captures(ui wToMove, ui ply, BB *moveList, sPos *pos, 
	    sPlyData *plyData, sOthers *others, ui psedolegal);
ui nonCaptures(ui wToMove, ui ply, BB *moveList, sPos *pos, sPlyData *plyData, 
	       sOthers *others, ui pseudolegal);
void makeMove(ui wToMove, ui ply, BB move, sPos *pos, sPlyData *plyData, 
	      sOthers *others);
void unmakeMove(ui wToMove, ui ply, BB move, sPos *pos, sPlyData *plyData);
ui outOfBCheck(ui ply, ui kSq, BB Checkers, BB *moveList, sPos *pos, 
	       sPlyData *plyData, sOthers *others);
ui outOfWCheck(ui ply, ui kSq, BB Checkers, BB *moveList, sPos *pos, 
	       sPlyData *plyData, sOthers *others);
void perft(ui wToMove, ui ply, ui depth, sPos *pos, sPlyData *plyData, 
	   sOthers *others);


/* pmRandom.c */
void setRandomSeed(unsigned long initial_seed);
unsigned long random31(void);
unsigned long random32(void);
BB random64(void);


/* search.c */
int qsearch(ui wToMove, ui ply, ui qDepth, int alpha, int beta, 
	    sPos *pos, sPlyData *plyData, sPV *pv, sOthers *others, sTC *tc, 
	    ui nullMode, ui isPVNode);
int rsearch(ui wToMove, int alpha, int beta, ui depth, sPos *pos, 
	    sPlyData *plyData, sPV *pv, sHash **hash, sOthers *others, sTC *tc,
	    BB* allMoves, ui nMoves, int origCE, ui highBF, sPV *thePV);


/* util.c */
void initFLOne(void);
void san(ui wToMove, ui ply, BB move, char *s, sPos *pos, sPlyData *plyData, 
	 sOthers *others);
void algebraic(BB move, char *s);
void display(sPos *pos);
#ifdef VERIFY
void displayBitBoard(BB BitBoard);
void displayBitRank(ui bitRank);
#endif
void setBoard(char* s1, char s2, char* s3, char* s4, char* s5, char* s6,
	      ui *wToMove, sPos *pos, sPlyData *thisPlyData, sOthers *others);
void getFEN(ui wToMove, sPos *pos, sPlyData *thisPlyData, char *fen);
void reverse(ui *wToMove, sPos *pos, sPlyData *thisPlyData, sOthers *others, 
	     char *fen);
void pick(ui head, ui tail, BB *moveList);
void closing(FILE *fd, sPos *pos, char *result, char *comment);
void exiting(FILE *fd, sHash **hash);


/* bitstuffs.s */
ui firstOne(BB BitBoard);
ui lastOne(BB BitBoard);
ui bitCount(BB BitBoard);


/* egtb.cpp */
int FTbSetCacheSize(void *EGTB_cache, int EGTB_cache_size);
int IInitializeTb(char *pszPath);
int IDescFindFromCounters (int *rgiCounters);


#ifdef LINUX
#if !defined(WINDOWS)
/* <sys/time.h>, declare it to please splint */
int gettimeofday(struct timeval *tv, struct timezone *tz);
#endif
#endif
